<%
'*********************************************************************************
' 7.00
' 1 Dec 2009
' ups routines
'*********************************************************************************
if getsess("inadminflag") <> "Yes" then
%>
<!-- #include file="shophash.asp"-->
<%
end if
setsess "inadminflag",""

const upshashkey = "oiYhaTdaDa"

dim pos, workrecord, words(2000), wordloc, wordcount, morewords
dim statuscode, statusmessage

'6.50 - Handle UPS 2007 Web Services Changes
dim ignoreerror
ignoreerror = True

sub AnalyzeXML
   if getupsconfig("xtracexml", false, dbc) = "Yes" then
      DebugWrite "Data returned"
      DebugWrite server.htmlencode(result)
   end if

   pos = 0
   Workrecord = replace(result, "<", "~")
   Workrecord = replace(workrecord, ">", "~")
   ParseRecord workrecord, words, Wordcount, "~"
   wordloc = 0
   morewords = TRUE
   do while morewords = TRUE
      ProcessWord Words(wordloc)
      wordloc = wordloc + 1
      if wordloc>wordcount then
         morewords = false
      end if
   loop

   if Statuscode<>"1" then
      xmlerror = "ERROR: DATA RETRIEVAL FAILED"
   end if
end sub

sub AnalyzeLicenseRequestXML
   if getupsconfig("xtracexml", false, dbc) = "Yes" then
      DebugWrite "Data returned"
      DebugWrite server.htmlencode(result)
   end if

   pos = 0
   Workrecord = replace(result, "<", "~")
   Workrecord = replace(workrecord, ">", "~")
   ParseRecord workrecord, words, Wordcount, "~"
   wordloc = 0
   morewords = TRUE
   do while morewords = TRUE
      ProcessWord Words(wordloc)
      wordloc = wordloc + 1
      if wordloc>wordcount then
         morewords = false
      end if
   loop

   if statusmessage = "Invalid license for the tool" then
      xmlerror = "ERROR: You need to re-register with UPS."
   end if

   if Statuscode<>"1" then
      xmlerror = "ERROR: DATA RETRIEVAL FAILED"
   end if
end sub

sub Processword (fieldname)
   dim tempoption, tempprice, ufieldname
   dim code, shippingmethod
   ufieldname = ucase(fieldname)
   select case uFieldname
      case "USERID"
         Morewords = FALSE
         Statusmessage = words(wordloc + 1)
         exit sub
      case "RESPONSESTATUSCODE"
         Statuscode = words(wordloc + 1)
         wordloc = wordloc + 1
         exit sub
      case "ERRORCODE"
         Statuscode = words(wordloc + 1)
         wordloc = wordloc + 1
         exit sub
      case "RESPONSESTATUSDESCRIPTION"
         StatusMessage = words(wordloc + 1)
         wordloc = wordloc + 1
         exit sub
      case "/RATEDSHIPMENT"
         shippingcount = shippingcount + 1
         wordloc = wordloc + 1
         exit sub
      case "DELIVERYDATE"
         ShippingDates(shippingcount) = words(wordloc + 1)
         wordloc = wordloc + 1
         exit sub
      case "RATEDSHIPMENT"
         wordloc = wordloc + 5
         code = words(wordloc)
         ServiceType = Convertshippingcode(code)
         wordloc = wordloc + 1
         ChargesFound = false
         exit sub
      case "/RATEDPACKAGE"
         AddServicePrice servicetype, serviceprice, servicedate
         wordloc = wordloc + 1
         exit sub
      case "TOTALCHARGES"
         wordloc = wordloc + 6
         if chargesfound = false then
            ServicePrice = words(wordloc + 1)
            wordloc = wordloc + 1
            chargesfound = true
         end if
         exit sub
      case "/RATINGSERVICESELECTIONRESPONSE"
         MoreWords = False
         wordloc = wordloc + 1
         exit sub
      '6.50 - handle UPS 2007 changes
      case "ERRORDESCRIPTION"
         if not ignoreerror then
            MoreWords = FALSE
            Statusmessage = words(wordloc + 1) & "<br>"
         end if
         exit sub
      case "ERRORSEVERITY"
         if ucase(words(wordloc + 1)) = "WARNING" then
            ignoreerror = True
         else
            ignoreerror = False
         end if
         exit sub
      case "ACCESSLICENSETEXT"
         MoreWords = FALSE
         Statusmessage = words(wordloc + 1)
         exit sub
      case "ACCESSLICENSENUMBER"
         MoreWords = FALSE
         Statusmessage = words(wordloc + 1)
         exit sub
   end select
end sub

sub AddUPSAccessKeyToConfig
   dim sql, rs

   '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      sql = "select * from ups_config limit 0,1"
   else
      sql = "select TOP 1 * from ups_config"
   end if
   set rs = Server.createobject("ADODB.RecordSet")
   rs.open SQL, dbc, adOpenKeyset, adLockOptimistic, adcmdText

   if not rs.eof then
      '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
	  if instr(ucase(xdatabasetype), "MYSQL") > 0 then
         '6.50 - precautionary security fix
         sql = "update ups_config set xupsacctno = '" & CleanChars(request("upsaccountno")) & "', AccessLicenceNum = '" & replace(EnDeCrypt(statusmessage, upshashkey), "'", "''") & "'"
         dbc.execute sql
      else
         '6.50 - precautionary security fix
         rs("xupsacctno") = CleanChars(request("upsaccountno"))
         rs("AccessLicenceNum") = EnDeCrypt(statusmessage, upshashkey)
         rs.update
      end if
   end if
   CloseRecordSet rs
end sub

sub AddUPSUserDataToConfig
   '700 - 2010.06.14 - Enhancement: Always make sure UPS encryption as 1252 encoding
   '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
   Assigncodepagevalue 1252

   dim sql, rs

   '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      sql = "select * from ups_config limit 0,1"
   else
      sql = "select TOP 1 * from ups_config"
   end if
   set rs = Server.createobject("ADODB.RecordSet")
   rs.open SQL, dbc, adOpenKeyset, adLockOptimistic, adcmdText

   if not rs.eof then
      '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
	  if instr(ucase(xdatabasetype), "MYSQL") > 0 then
         sql = "update ups_config set username = '"
         if ucase(statusmessage) <> "SUCCESS" then
            sql = sql & EnDeCrypt(statusmessage, upshashkey) & "', "
         else
            sql = sql & EnDeCrypt(GetSess("username"), upshashkey) & "', "
         end if

         sql = sql & "Password = '" & EnDeCrypt(GetSess("password"), upshashkey) & "'"
         dbc.execute sql
      else
         if ucase(statusmessage) <> "SUCCESS" then
            rs("Username") = EnDeCrypt(statusmessage, upshashkey)
         else
            rs("Username") = EnDeCrypt(GetSess("username"), upshashkey)
         end if

         rs("Password") = EnDeCrypt(GetSess("password"), upshashkey)
         rs.update
      end if
   end if
   CloseRecordSet rs

   '700 - 2010.06.14 - Enhancement: Always make sure UPS encryption as 1252 encoding
   '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
   Assigncodepagevalue 65001
end sub

sub AddUPSToShipMethods
   dim sql, rs

   'CHECK IF UPS ALREADY EXISTS IN SHIPEMTHODS TABLE
   sql = "select * from shipmethods where shiproutine = 'upsxmlrealtime.asp'"
   Set rs = Server.CreateObject("ADODB.Recordset")
   rs.open sql, dbc, adOpenDynamic, adLockOptimistic
   'IF NOT, ADD IT
   if rs.eof then
      sql = "insert into shipmethods (shipmethod,shiproutine, shipcountry) VALUES ('UPS Real-Time','upsxmlrealtime.asp', 'other')"
   end if
   set rs = dbc.execute(sql)
   set rs = nothing
end sub


sub RemoveUPSFromConfig
   dim sql, rs

   '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      sql = "select * from ups_config limit 0,1"
   else
      sql = "select TOP 1 * from ups_config"
   end if
   set rs = Server.createobject("ADODB.RecordSet")
   rs.open SQL, dbc, adOpenKeyset, adLockOptimistic, adcmdText

   if not rs.eof then
      '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
	  if instr(ucase(xdatabasetype), "MYSQL") > 0 then
         sql = "update ups_config set xupsacctno = '', AccessLicenceNum = '', username = '', password = ''"
         dbc.execute sql
      else
         rs("xupsacctno") = ""
         rs("AccessLicenceNum") = ""
         rs("Username") = ""
         rs("Password") = ""
         rs.update
      end if
   end if
   CloseRecordSet rs

   sql = "delete from shipmethods WHERE shiproutine = 'upsxmlrealtime.asp'"
   set rs = dbc.execute(sql)
   set rs = nothing
end sub

sub RequestLicense
   dim xmlstring

   'Create request doc
   xmlstring = xmlstring&"<?xml version=""1.0"" encoding = ""ISO-8859-1""?>" '
   xmlstring = xmlstring&"<AccessLicenseAgreementRequest>"
   xmlstring = xmlstring&"<Request>"
   xmlstring = xmlstring&"<TransactionReference>"
   xmlstring = xmlstring&"<CustomerContext>EULA Text</CustomerContext>"
   xmlstring = xmlstring&"<XpciVersion>1.0001</XpciVersion>"
   xmlstring = xmlstring&"</TransactionReference>"
   xmlstring = xmlstring&"<RequestAction>AccessLicense</RequestAction>"
   xmlstring = xmlstring&"<RequestOption>AllTools</RequestOption>"
   xmlstring = xmlstring&"</Request>"
   '700 - 2010.05.06 - Bug Fix: UPS Registration is not working.
   'xmlstring = xmlstring&"<DeveloperLicenseNumber>" & GetUPSConfig("developerkey", true, dbc) & "</DeveloperLicenseNumber>"
   xmlstring = xmlstring&"<DeveloperLicenseNumber>FBD953535386AF70</DeveloperLicenseNumber>"
   xmlstring = xmlstring&"<AccessLicenseProfile>"
   xmlstring = xmlstring&"<CountryCode>US</CountryCode>"
   xmlstring = xmlstring&"<LanguageCode>FR</LanguageCode>"
   xmlstring = xmlstring&"</AccessLicenseProfile>"
   xmlstring = xmlstring&"<OnLineTool>"
   xmlstring = xmlstring&"<ToolID>TrackXML</ToolID>"
   xmlstring = xmlstring&"<ToolVersion>1.0</ToolVersion>"
   xmlstring = xmlstring&"</OnLineTool>"
   xmlstring = xmlstring&"<OnLineTool>"
   xmlstring = xmlstring&"<ToolID>RateXML</ToolID>"
   xmlstring = xmlstring&"<ToolVersion>1.0</ToolVersion>"
   xmlstring = xmlstring&"</OnLineTool>"
   xmlstring = xmlstring&"</AccessLicenseAgreementRequest>"

   Shopxmlhttp getupsconfig("xml", false, dbc), getupsconfig("gatewaylocation_license", false, dbc), xmlstring, result, "POST", xmlerror
end sub

function GetUPSConfig (fieldname, encrypted, dbc)
   '700 - 2010.06.14 - Enhancement: Always make sure UPS encryption as 1252 encoding
   '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
   Assigncodepagevalue 1252

   dim sql, upsrs, tempconfig

   sql = "select " & fieldname & " from ups_config"

   Set upsrs = Server.CreateObject("ADODB.Recordset")
   upsrs.open sql, dbc, adOpenDynamic, adLockOptimistic
   '6.09 - changed this IF from one line to two for greater accuracy
   if not upsrs.eof then
      if trim(upsrs(fieldname)) <> "" and isnull(upsrs(fieldname)) = false then
         if encrypted = true then
            tempconfig = EnDeCrypt(upsrs(fieldname), upshashkey)
         else
            tempconfig = upsrs(fieldname)
         end if
      end if
   end if
   CloseRecordSet upsrs
   GetUPSConfig = tempconfig

   '700 - 2010.06.14 - Enhancement: Always make sure UPS encryption as 1252 encoding
   '700 - 2010.09.08 - Enhancment: Cover Old IIS issue
   Assigncodepagevalue 65001
end function

sub AccessLicenseRequest
   RequestLicense

   if result > "" then
      dim xmldoc
      set xmlDoc = Server.createobject("MSXML2.DOMDocument")
      xmlDoc.async = False

      if xmlDoc.loadxml(result) then
         xmlDoc.setProperty "SelectionLanguage", "XPath"
         set upslicense = xmlDoc.selectSingleNode("AccessLicenseAgreementResponse/AccessLicenseText")
      else
         response.write "LICENSE ERROR reading XML: " & xmldoc.parseError.reason & " (line: " & xmldoc.parseError.line & ")"
         response.end
         statuscode = 0
         exit sub
      end if
   else
      response.write "LICENSE ERROR reading result"
      response.end
      statuscode = 0
      exit sub
   end if

   xmlstring = xmlstring & "<?xml version=""1.0"" encoding=""ISO-8859-1"" ?>" ' encoding=""ISO-8859-1""
   xmlstring = xmlstring & "<AccessLicenseRequest xml:lang=""en-US"">" ' xml:lang=""en-US""
   xmlstring = xmlstring & "<Request>"
   xmlstring = xmlstring & "<TransactionReference>"
   xmlstring = xmlstring & "<CustomerContext>Access Key Request</CustomerContext>"
   xmlstring = xmlstring & "<XpciVersion>1.0001</XpciVersion>"
   xmlstring = xmlstring & "</TransactionReference>"
   xmlstring = xmlstring & "<RequestAction>AccessLicense</RequestAction>"
   xmlstring = xmlstring & "<RequestOption>AllTools</RequestOption>"
   xmlstring = xmlstring & "</Request>"
   xmlstring = xmlstring & "<CompanyName>"& GetSess("companyname")&"</CompanyName>"
   xmlstring = xmlstring & "<Address>"
   xmlstring = xmlstring & "<AddressLine1>"& GetSess("streetaddress")&"</AddressLine1>"
   xmlstring = xmlstring & "<City>"& GetSess("City")&"</City>"
   xmlstring = xmlstring & "<StateProvinceCode>"&GetSess("strState")&"</StateProvinceCode>"
   xmlstring = xmlstring & "<PostalCode>"&GetSess("PostalCode")&"</PostalCode>"
   xmlstring = xmlstring & "<CountryCode>"&GetSess("strCountry")&"</CountryCode>"
   xmlstring = xmlstring & "</Address>"
   xmlstring = xmlstring & "<PrimaryContact>"
   xmlstring = xmlstring & "<Name>"& GetSess("ContactName")&"</Name>"
   xmlstring = xmlstring & "<Title>"& GetSess("Title")&"</Title>"
   xmlstring = xmlstring & "<PhoneNumber>"&GetSess("phonenumber")&"</PhoneNumber>"
   xmlstring = xmlstring & "<EMailAddress>"&GetSess("emailaddress")&"</EMailAddress>"
   xmlstring = xmlstring & "</PrimaryContact>"
   xmlstring = xmlstring & "<CompanyURL>"&GetSess("websiteurl")&"</CompanyURL>"
   xmlstring = xmlstring & "<ShipperNumber>"&GetSess("upsaccountno")&"</ShipperNumber>"
   '700 - 2010.05.06 - Bug Fix: UPS Registration is not working.
   'xmlstring = xmlstring & "<DeveloperLicenseNumber>" & GetUPSConfig("developerkey", true, dbc) & "</DeveloperLicenseNumber>"
   xmlstring = xmlstring & "<DeveloperLicenseNumber>FBD953535386AF70</DeveloperLicenseNumber>"
   xmlstring = xmlstring & "<AccessLicenseProfile>"
   xmlstring = xmlstring & "<CountryCode>"&GetSess("strCountry")&"</CountryCode>"
   xmlstring = xmlstring & "<LanguageCode>EN</LanguageCode>"
   xmlstring = xmlstring & "<AccessLicenseText>"& Server.HTMLEncode(upslicense.nodeTypedValue) &"</AccessLicenseText>"
   xmlstring = xmlstring & "</AccessLicenseProfile>"
   xmlstring = xmlstring & "<OnLineTool>"
   xmlstring = xmlstring & "<ToolID>TrackXML</ToolID>"
   xmlstring = xmlstring & "<ToolVersion>1.0</ToolVersion>"
   xmlstring = xmlstring & "</OnLineTool>"
   xmlstring = xmlstring & "<OnLineTool>"
   xmlstring = xmlstring & "<ToolID>RateXML</ToolID>"
   xmlstring = xmlstring & "<ToolVersion>1.0</ToolVersion>"
   xmlstring = xmlstring & "</OnLineTool>"
   xmlstring = xmlstring & "<ClientSoftwareProfile>"
   xmlstring = xmlstring & "<SoftwareInstaller>"&GetSess("upscontact")&"</SoftwareInstaller>"
   xmlstring = xmlstring & "<SoftwareProductName>VP-ASP</SoftwareProductName>"
   xmlstring = xmlstring & "<SoftwareProvider>Rock Salt International Pty Ltd</SoftwareProvider>"
   xmlstring = xmlstring & "<SoftwareVersionNumber>6.00</SoftwareVersionNumber>"
   xmlstring = xmlstring & "</ClientSoftwareProfile>"
   xmlstring = xmlstring & "</AccessLicenseRequest>"

   Shopxmlhttp getupsconfig("xml", false, dbc), getupsconfig("gatewaylocation_license", false, dbc), xmlstring, result, "POST", xmlerror
   AnalyzeLicenseRequestXML
end sub

sub AddFormToSession
   '6.50 - precautionary security fix
   SetSess "contactname", CleanChars(request("contactname"))
   SetSess "title", CleanChars(request("title"))
   SetSess "companyname", CleanChars(request("companyname"))
   SetSess "streetaddress", CleanChars(request("streetaddress"))
   SetSess "city", CleanChars(request("city"))
   SetSess "strState", CleanChars(request("strState"))
   SetSess "strCountry", CleanChars(request("strCountry"))
   SetSess "postalcode", CleanChars(request("postalcode"))
   SetSess "phonenumber", CleanChars(request("phonenumber"))
   SetSess "websiteurl", CleanChars(request("websiteurl"))
   SetSess "emailaddress", CleanChars(request("emailaddress"))
   SetSess "upsaccountno", CleanChars(request("upsaccountno"))
   SetSess "upscontact", CleanChars(request("upscontact"))
end sub

sub LicenseError
%>
<table width="50%" cellpadding=3 border="0">
  <tr>
    <td><table width="100%"  border="0" cellpadding="3">
        <tr>
          <td width="17%" valign="top"><img src="images/ups_logo.gif" width="76" height="78"></td>
          <td width="83%"><center>
              There has been an error: <br />
              <span class='fontbold'><%=statusmessage%></span> <br />
              Please click the Back button on your browser to try again.
            </center></td>
        </tr>
      </table>
      <p>UPS, UPS brandmark, and the Color Brown are trademarks of United Parcel Service of America, Inc. All Rights Reserved.</p></td>
  </tr>
</table>
<%
end sub

sub RegistrationRequest
   dim xmlstring

   'Create request doc
   xmlstring = xmlstring&"<?xml version=""1.0""?>"
   xmlstring = xmlstring&"<RegistrationRequest>"
   xmlstring = xmlstring&"<Request>"
   xmlstring = xmlstring&"<TransactionReference>"
   xmlstring = xmlstring&"<CustomerContext>x893</CustomerContext>"
   xmlstring = xmlstring&"<XpciVersion>1.0001</XpciVersion>"
   xmlstring = xmlstring&"</TransactionReference>"
   xmlstring = xmlstring&"<RequestAction>Register</RequestAction>"
   xmlstring = xmlstring&"<RequestOption>suggest</RequestOption>"
   xmlstring = xmlstring&"</Request>"
   SetSess "username", generaterandomthing
   xmlstring = xmlstring&"<UserId>" & GetSess("username") & "</UserId>"
   SetSess "password", generaterandomthing
   xmlstring = xmlstring&"<Password>" & GetSess("password") & "</Password>"
   xmlstring = xmlstring&"<RegistrationInformation>"
   xmlstring = xmlstring&"<UserName>" & GetSess("contactname") & "</UserName>"
   xmlstring = xmlstring&"<CompanyName>" & GetSess("companyname") & "</CompanyName>"
   xmlstring = xmlstring&"<Title>" & GetSess("title") & "</Title>"
   xmlstring = xmlstring&"<Address>"
   xmlstring = xmlstring&"<AddressLine1>" & GetSess("streetaddress") & "</AddressLine1>"
   xmlstring = xmlstring&"<City>" & GetSess("city") & "</City>"
   xmlstring = xmlstring&"<StateProvinceCode>" & GetSess("strstate") & "</StateProvinceCode>"
   xmlstring = xmlstring&"<PostalCode>" & GetSess("postalcode") & "</PostalCode>"
   xmlstring = xmlstring&"<CountryCode>" & GetSess("strcountry") & "</CountryCode>"
   xmlstring = xmlstring&"</Address>"
   xmlstring = xmlstring&"<PhoneNumber>" & GetSess("phonenumber") & "</PhoneNumber>"
   xmlstring = xmlstring&"<EMailAddress>" & GetSess("emailaddress") & "</EMailAddress>"
   xmlstring = xmlstring&"<ShipperNumber>" & GetSess("upsaccountno") & "</ShipperNumber>"
   xmlstring = xmlstring&"<PickupPostalCode>" & GetSess("postalcode") & "</PickupPostalCode>"
   xmlstring = xmlstring&"<PickupCountryCode>" & GetSess("strcountry") & "</PickupCountryCode>"
   xmlstring = xmlstring&"</RegistrationInformation>"
   xmlstring = xmlstring&"</RegistrationRequest>"
   
   Shopxmlhttp getupsconfig("xml", false, dbc), getupsconfig("gatewaylocation_register", false, dbc), xmlstring, result, "POST", xmlerror
   AnalyzeXML
end sub

function generaterandomthing
   dim randomnumber
   randomize()
   randomnumber = int((9999 - 1000 + 1) * rnd + 1000)
   generateRandomThing = left(replace(GetSess("contactname"), " ", ""), 3) & randomnumber & left(replace(GetSess("phonenumber"), " ", ""), 3)
end function

sub AddMerchantInfoToConfig
   dim sql, rs

   '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
   if instr(ucase(xdatabasetype), "MYSQL") > 0 then
      sql = "select * from ups_config limit 0,1"
   else
      sql = "select TOP 1 * from ups_config"
   end if
   set rs = Server.createobject("ADODB.RecordSet")
   rs.open SQL, dbc, adOpenKeyset, adLockOptimistic, adcmdText

   if not rs.eof then
      '6.50 - broadened defintion of IF statement to cover cases where xmysql hasn't been set
	  if instr(ucase(xdatabasetype), "MYSQL") > 0 then
         '6.50 - precautionary security fix
         sql = "update ups_config set xMerchantCountry = '" & CleanChars(request("strCountry")) & "', xMerchantState = '" & CleanChars(request("strState")) & "', "
         sql = sql & "xMerchantCity = '" & CleanChars(request("city")) & "', xMerchantPostcode = '" & CleanChars(request("postalcode")) & "'"
         dbc.execute sql
      else
         '6.50 - precautionary security fix
         rs("xMerchantCountry") = CleanChars(request("strCountry"))
         rs("xMerchantState") = CleanChars(request("strState"))
         rs("xMerchantCity") = CleanChars(request("city"))
         rs("xMerchantPostcode") = CleanChars(request("postalcode"))
         rs.update
      end if
   end if
   CloseRecordSet rs
end sub

sub ReloadConfig()
   dim InitName
   InitName = "init" & "_" & xShopId
   application(InitName) = ""
   LoadApplicationVariables
   setconfig shoplcname, ""
end sub
%>